#include <stdio.h>
#include <stdlib.h>
#include <mpi.h>

int main(int argc, char* argv[]) {
  int gath_root = 0;

  int size, rank, ierror, value;
  int *buffer;

  MPI_Init(&argc, &argv);
  MPI_Comm_size(MPI_COMM_WORLD, &size);
  MPI_Comm_rank(MPI_COMM_WORLD, &rank);

  value = rank * 100;

  printf("Process %d has value %d.\n", rank, value);

  buffer = (int*)malloc(sizeof(int)*size);
  MPI_Allgather(&value, 1, MPI_INT, buffer, 1, MPI_INT, MPI_COMM_WORLD);

  printf("Values collected on process %d:", rank);
  for (int i = 0; i < size; ++i) printf(" %d", buffer[i]);
  printf(".\n");

  free(buffer);

  MPI_Finalize();

  return 0;
}