#include <stdio.h>
#include <stdlib.h>
#include <mpi.h>

int main(int argc, char* argv[]) {
    MPI_Init(&argc, &argv);

    int rank, size;
    MPI_Comm_size(MPI_COMM_WORLD, &size);
    MPI_Comm_rank(MPI_COMM_WORLD, &rank);

    int* sendbuf = (int*)malloc(sizeof(int)*size);
    int* recvbuf = (int*)malloc(sizeof(int)*size);

    for (int i = 0; i < size; ++i)
        sendbuf[i] = (rank * size + i) * 100;

    printf("Process %d will send", rank);
    for (int i = 0; i < size; ++i) printf(" %d", sendbuf[i]);
    printf("\n");

    MPI_Alltoall(sendbuf, 1, MPI_INT, recvbuf, 1, MPI_INT, MPI_COMM_WORLD);

    printf("Process %d collected values", rank);
    for (int i = 0; i < size; ++i) printf(" %d", recvbuf[i]);
    printf("\n");

    free(sendbuf); free(recvbuf);
    MPI_Finalize();

    return 0;
}