#include <stdio.h>
#include <stdlib.h>
#include <mpi.h>

int main(int argc, char* argv[]) {
  MPI_Init(&argc, &argv);
 
  int rank;
  MPI_Comm_rank(MPI_COMM_WORLD, &rank);
 
  int bcast_root = 0;
 
  int data;
  if(rank == bcast_root) {
      data = 12345;
      printf("I am the broadcast root with rank %d, and send value %d.\n", rank, data);
  }

  MPI_Bcast(&data, 1, MPI_INT, bcast_root, MPI_COMM_WORLD);

  if(rank != bcast_root) {
      printf("I am a broadcast receiver with rank %d, and obtained value %d.\n", rank, data);
  }

  MPI_Finalize();

  return 0;
} 