#include <stdio.h>
#include <mpi.h>

int main (int argc, char *argv[]) {
  int rank, size;
  int right_rank, left_rank;
  int recv_buf, send_buf;
  int sum;

  MPI_Status  status;
  MPI_Request request;

  MPI_Init(&argc, &argv);

  MPI_Comm_rank(MPI_COMM_WORLD, &rank);
  MPI_Comm_size(MPI_COMM_WORLD, &size);

  right_rank = (rank+1     ) % size;
  left_rank  = (rank-1+size) % size;

  sum = 0;
  send_buf = rank;

  for(int j = 0; j < size; ++j) {
    MPI_Isend(&send_buf, 1, MPI_INT, right_rank, 10, MPI_COMM_WORLD, &request);
    MPI_Recv(&recv_buf, 1, MPI_INT, left_rank, 10, MPI_COMM_WORLD, &status);
  
    MPI_Wait(&request, &status);

    send_buf = recv_buf;
    sum += recv_buf;
  }

  printf("Process %d: sum = %d\n", rank, sum);

  MPI_Finalize();
}