#include <stdio.h>
#include <stdlib.h>
#include <mpi.h>
 

int main(int argc, char* argv[]) {
    MPI_Init(&argc, &argv);
 
    int size, rank, value, scatt_root = 0;
    MPI_Comm_size(MPI_COMM_WORLD, &size);
    MPI_Comm_rank(MPI_COMM_WORLD, &rank);
   
    if(rank == scatt_root) {
        int* data = (int*)malloc(sizeof(int) * size);

        printf("Values to scatter from process %d:", rank);

        for (int i = 0; i < size; i++) {
            data[i] = 100 * i;
            printf(" %d", data[i]);
        }

        printf("\n");

        MPI_Scatter(data, 1, MPI_INT, &value, 1, MPI_INT, scatt_root, MPI_COMM_WORLD);

        free(data);
    } else {
        MPI_Scatter(NULL, 1, MPI_INT, &value, 1, MPI_INT, scatt_root, MPI_COMM_WORLD);
    }
 
    printf("Process %d received value %d.\n", rank, value);
    
    MPI_Finalize();
 
    return EXIT_SUCCESS;
}