#include <stdio.h>
#include <stdlib.h>
#include <mpi.h>
 
int main(int argc, char* argv[]) {
  int rank, size;
  
  int *sendbuf, *recvbuf;
  int *displs, *nelems;
  
  MPI_Init(&argc, &argv);
  MPI_Comm_size(MPI_COMM_WORLD, &size);
  MPI_Comm_rank(MPI_COMM_WORLD, &rank);
    
  if (rank == 0) {
    int n = size*(size+1)/2;
        
    sendbuf = (int*)malloc(sizeof(int)*n);
    displs  = (int*)malloc(sizeof(int)*size);
    nelems  = (int*)malloc(sizeof(int)*size);
     
    for (int i = 0; i < n; ++i) sendbuf[i] = 100*(i+1);
  
    for (int i = 0; i < size; ++i) {
      displs[i] = i*(i+1)/2;
      nelems[i] = i+1;
    }
  }
    
  recvbuf = (int*)malloc(sizeof(int)*(rank+1));
    
  MPI_Scatterv(sendbuf, nelems, displs, MPI_INT, recvbuf, rank+1, MPI_INT, 0, MPI_COMM_WORLD);
  
  printf("Process %d received values:", rank);
  for(int i = 0; i < rank+1; i++) printf(" %d", recvbuf[i]);
  printf("\n");

  free(recvbuf);

  if (rank == 0) {
    free(sendbuf);
    free(displs);
    free(nelems);
  }

  MPI_Finalize();

  return 0;
}