    program main
      use mpi
    
      implicit none
    
      integer, parameter :: nsteps = 1000
      integer, parameter :: problem_size = 100000
    
      double precision, parameter :: alpha = 0.1
    
      integer :: rank, size
      integer :: right_rank, left_rank
      integer :: n, i, step, ierror
      
      double precision, dimension(:), allocatable :: u
      double precision, dimension(:), allocatable :: u_prev
        
      integer :: requests(4)
      integer :: statuses(MPI_STATUS_SIZE, 4)
    
      call MPI_Init(ierror)
    
      call MPI_Comm_rank(MPI_COMM_WORLD, rank, ierror)
      call MPI_Comm_size(MPI_COMM_WORLD, size, ierror)
    
      right_rank = mod(rank+1     , size)
      left_rank  = mod(rank-1+size, size)
    
      n = problem_size / size
      if (rank .lt. mod(N, size)) then
        n = n + 1
      end if
    
      allocate(     u(n+2))
      allocate(u_prev(n+2))
    
      do i = 1, n+2
             u(i) = 0.0
        u_prev(i) = 0.0
      end do
    
      if (rank .eq. 0) then
             u(2) = 100.0
        u_prev(2) = 100.0
      end if
    
      if (rank .eq. size-1) then
             u(n+1) = 100.0
        u_prev(n+1) = 100.0
      end if
    
      do step = 1, nsteps
        call MPI_Irecv(u_prev(1) , 1, MPI_DOUBLE, left_rank, 10, MPI_COMM_WORLD, requests(1), ierror)
        call MPI_Irecv(u_prev(n+2), 1, MPI_DOUBLE, right_rank, 20, MPI_COMM_WORLD, requests(2), ierror)
        
        call MPI_Isend(u_prev(2) , 1, MPI_DOUBLE, left_rank, 20, MPI_COMM_WORLD, requests(3), ierror)
        call MPI_Isend(u_prev(n+1) , 1, MPI_DOUBLE, right_rank, 10, MPI_COMM_WORLD, requests(4), ierror)
    
        do i = 3, n
          u(i) = u_prev(i) + alpha * (u_prev(i-1) - 2 * u_prev(i) + u_prev(i+1))
        end do
    
        call MPI_Waitall(4, requests, statuses, ierror)
    
          u(2) = u_prev(2) + alpha * (u_prev(1) - 2 * u_prev(2) + u_prev(3))
        u(n+1) = u_prev(n+1) + alpha * (u_prev(n) - 2 * u_prev(n+1) + u_prev(n+2))
    
        u_prev(1:n+2) = u(1:n+2)
      end do
    
      deallocate(u, u_prev)
    
      call MPI_Finalize(ierror)
    end program