    program main
      use mpi

      implicit none

      integer, parameter :: N = 10000000
      
      integer*8 :: proc_sum, remote_sum
      integer   :: rank, world_size, ierror
      integer   :: startidx, endidx, src, i
      integer   :: status(MPI_STATUS_SIZE)

      call MPI_Init(ierror)
            
      call MPI_Comm_size(MPI_COMM_WORLD, world_size, ierror)
      call MPI_Comm_rank(MPI_COMM_WORLD, rank, ierror)
    
      if (rank .eq. 0) then
        print 100, N, world_size
100     format('Sum of integer running from 1 to ', i0, ' on ', &
                & i0 ' processes.')
      end if
    
      startidx = (N * rank / world_size) + 1
        endidx = N * (rank+1) / world_size
      
      proc_sum = 0
      do i = startidx, endidx
        proc_sum = proc_sum + i
      end do
      
      print 200, rank, proc_sum
200   format('Process ' i0, ' has local sum ', i0, '.')
    
      if (rank .gt. 0) then
        call MPI_Send(proc_sum, 1, MPI_INTEGER8, 0, 1, MPI_COMM_WORLD, ierror)
      else
        do src = 1, world_size-1
          call MPI_Recv(remote_sum, 1, MPI_INTEGER8, src, 1, MPI_COMM_WORLD, status, ierror)
          proc_sum = proc_sum + remote_sum
        end do
      end if
    
      if (rank .eq. 0) then
        print 300, N, proc_sum
300     format('The sum of 1 to ', i0, ' is ' i0 '.')
      end if
    
      call MPI_Finalize(ierror)
    end