    program pingpong
      use mpi

      implicit none
      double precision, parameter :: bytes_to_gbytes = 1073741824.0
      integer*8, parameter        :: max_length = 134217728

      integer          :: rank, size, ierror, i, j, num_bytes 
      integer          :: length, status(MPI_STATUS_SIZE)
      double precision :: elapsed_time, num_gbytes, avg_time_per_transfer
      double precision :: buffer(max_length)

      call MPI_Init(ierror)
      call MPI_Comm_rank(MPI_COMM_WORLD, rank, ierror)

      length = 1

      do i = 0,27
        do j = 1,5
          if (rank .eq. 0) then
            call MPI_Send(buffer, length, MPI_DOUBLE, 1, 10, MPI_COMM_WORLD, ierror)
            call MPI_Recv(buffer, length, MPI_DOUBLE, 1, 20, MPI_COMM_WORLD, status, ierror)
          else if (rank .eq. 1) then
            call MPI_Recv(buffer, length, MPI_DOUBLE, 0, 10, MPI_COMM_WORLD, status, ierror)
            call MPI_Send(buffer, length, MPI_DOUBLE, 0, 20, MPI_COMM_WORLD, ierror)
          end if
        end do

        elapsed_time = -1.0 * MPI_Wtime()
        do j = 1,50
          if (rank .eq. 0) then
            call MPI_Send(buffer, length, MPI_DOUBLE, 1, 10, MPI_COMM_WORLD, ierror)
            call MPI_Recv(buffer, length, MPI_DOUBLE, 1, 20, MPI_COMM_WORLD, status, ierror)
          else if (rank .eq. 1) then
            call MPI_Recv(buffer, length, MPI_DOUBLE, 0, 10, MPI_COMM_WORLD, status, ierror)
            call MPI_Send(buffer, length, MPI_DOUBLE, 0, 20, MPI_COMM_WORLD, ierror)
          end if
        end do
        elapsed_time = elapsed_time + MPI_Wtime()
  
        num_bytes = 8*length
        num_gbytes = DBLE(num_bytes) / bytes_to_gbytes
        avg_time_per_transfer = elapsed_time / (2.0 * 50)
  
        if (rank .eq. 0) then
          print 100, num_bytes, avg_time_per_transfer, num_gbytes/avg_time_per_transfer
100       format('Transfer size (B): ', i10, ', Transfer Time (s): ', f15.9, ', Bandwidth (GB/s): ', f15.9)
        end if

        length = length * 2
      end do

      call MPI_Finalize(ierror)
    end program