    program main
      use mpi

      implicit none

      integer :: ierror, size, rank
      integer :: count, status(MPI_STATUS_SIZE)
      
      integer, allocatable :: buffer(:)
    
      call MPI_Init(ierror)
      call MPI_Comm_size(MPI_COMM_WORLD, size, ierror)
      call MPI_Comm_rank(MPI_COMM_WORLD, rank, ierror)
    
      if (rank .eq. 0) then
        allocate(buffer(count))
        buffer = (/123, 456, 789/)
        print 100, rank, buffer
100     format('Process ', i0, ': sending 3 ints:', 3(1x,i0), '.')
    
        call MPI_Send(buffer, 3, MPI_INTEGER, 1, 10, MPI_COMM_WORLD, ierror)
      else if (rank .eq. 1) then
        call MPI_Probe(0, 10, MPI_COMM_WORLD, status, ierror)
        call MPI_Get_count(status, MPI_INTEGER, count, ierror)
    
        print 200, rank, count
200     format('Process ', i0, ' retrieved the size of the message: ', i0, '.')
    
        allocate(buffer(count))
        call MPI_Recv(buffer, count, MPI_INTEGER, 0, 10, MPI_COMM_WORLD, status, ierror)
    
        print 300, rank, buffer
300     format('Process ', i0,' received message:', *(1x,i0), '.')
      end if
    
      deallocate(buffer)
    
      call MPI_Finalize(ierror)
    end program