    program main
      use mpi
    
      implicit none
    
      integer :: size, rank, ierror
      integer :: value, scatt_root
      integer :: i

      integer, dimension(:), allocatable :: buffer
    
      call MPI_Init(ierror)
      call MPI_Comm_size(MPI_COMM_WORLD, size, ierror)
      call MPI_Comm_rank(MPI_COMM_WORLD, rank, ierror)
          
      if (rank .eq. scatt_root) then
          allocate(buffer(size))

          do i = 1,size            
            buffer(i) = 100 * i
          end do

          print 100, rank, buffer
100       format('Values to scatter from process ', i0, ':', *(1x,i0))
      end if
    
      call MPI_Scatter(buffer, 1, MPI_INTEGER, value, 1, MPI_INTEGER, scatt_root, MPI_COMM_WORLD, ierror)
      
      print 200, rank, value
200   format('Process ', i0, ' received value ', i0)
      
      if (rank .eq. scatt_root) deallocate(buffer)
      
      call MPI_Finalize(ierror)
    end program