    program main
      use mpi
     
      implicit none
         
      integer :: rank, size, ierror, i, n
    
      integer, dimension(:), allocatable :: sendbuf
      integer, dimension(:), allocatable :: recvbuf
      integer, dimension(:), allocatable :: displs
      integer, dimension(:), allocatable :: nelems
     
      call MPI_Init(ierror)
      call MPI_Comm_size(MPI_COMM_WORLD, size, ierror)
      call MPI_Comm_rank(MPI_COMM_WORLD, rank, ierror)
    
      if(rank .eq. 0) then
        n = size*(size+1)/2
        
        allocate(sendbuf(n))
        allocate(displs(size), nelems(size))
    
        do i = 1,n
          sendbuf(i) = 100*i
        end do
    
        do i = 1,size
          displs(i) = i*(i-1)/2
          nelems(i) = i
        end do
      end if
    
      allocate(recvbuf(rank+1))
    
      call MPI_Scatterv(sendbuf, nelems, displs, MPI_INTEGER, recvbuf, rank+1, MPI_INTEGER, 0, MPI_COMM_WORLD, ierror)
    
      print 100, rank, recvbuf
100   format('Process ', i0, ' received values:', *(1x,i0))
      
      deallocate(recvbuf)

      if (rank .eq. 0) deallocate(sendbuf, displs, nelems)

      call MPI_Finalize(ierror)
    end program