    program main
      use mpi
    
      implicit none
    
      character(len = 20) :: sendbuf
      character(len = 20) :: recvbuf = ''
    
      integer :: msgsize, size, rank, ierror
      integer :: status(MPI_STATUS_SIZE)
    
      call MPI_Init(ierror);
      call MPI_Comm_size(MPI_COMM_WORLD, size, ierror)
      call MPI_Comm_rank(MPI_COMM_WORLD, rank, ierror)
    
      if (size .ne. 2) call MPI_Abort(MPI_COMM_WORLD, 1, ierror)
    
      if(rank .eq. 0) then
        sendbuf = 'Hello Mate!'
        call MPI_Send(sendbuf, LEN_TRIM(sendbuf), MPI_CHAR, 1, 10, MPI_COMM_WORLD, ierror)
      else
        call MPI_Probe(MPI_ANY_SOURCE, MPI_ANY_TAG, MPI_COMM_WORLD, status, ierror)
        call MPI_Get_count(status, MPI_CHAR, msgsize, ierror)
    
        print 100, status(MPI_SOURCE), status(MPI_TAG), msgsize
100     format('Message incoming from process ', i0, ' with tag ', i0,' and size ', i0)
        
        call MPI_Recv(recvbuf, msgsize, MPI_CHAR, status(MPI_SOURCE), status(MPI_TAG), MPI_COMM_WORLD, MPI_STATUS_IGNORE, ierror)
    
        print 200, recvbuf
200     format('Received message: ', a)
      end if
    
      call MPI_Finalize(ierror)
    end program