#!/bin/bash
#SBATCH --job-name=mpi-openmp-job
#SBATCH --time=00:01:00 # hh:mm:ss
#SBATCH --ntasks=2 #number of MPI processes
#SBATCH --cpus-per-task=12 #number of OpenMP threads
#SBATCH --mem-per-cpu=2048 # megabytes
#SBATCH --partition=batch
#SBATCH --output=mpi_openmp_output.out

module load OpenMPI/3.1.4-GCC-8.3.0
cd $SLURM_SUBMIT_DIR

export OMP_NUM_THREADS=$SLURM_CPUS_PER_TASK

mpirun -np $SLURM_NTASKS ./your_program